﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Syncfusion.DocIO.DLS;
using System.ComponentModel;
using Syncfusion.DocIO;

using System.Web;
using System.IO;


namespace ConsoleApplication1
{
    class Program
    {


        static void Main(string[] args)
        {

            string fileName = @"Documents\Donor Annual Statement.docx";
            string GetDirectoryName = AppDomain.CurrentDomain.BaseDirectory;
            string path = Path.Combine(GetDirectoryName, fileName);

            //Opens the template document
            WordDocument document = new WordDocument(path);

            BookmarksNavigator bookmarkNavigator = new BookmarksNavigator(document);

            //Gets the bookmark by it's name
            Bookmark bookmark = document.Bookmarks.FindByName("AccountDate");
            //Gets the owner paragraph of Bookmart start
            WParagraph para = bookmark.BookmarkStart.OwnerParagraph;
            //Checks whether paragaph is defined within table cell

            //Gets the bookmark by it's name
            Bookmark bookmark2 = document.Bookmarks.FindByName("GivingAccountNumber");
            //Gets the owner paragraph of Bookmart start
            WParagraph ParagraphTemplate = bookmark2.BookmarkStart.OwnerParagraph;
            //Checks whether paragaph is defined within table cell


            //Checks whether paragaph is defined within table cell
            WTableRow row = null;          
            WTable templateTable = null; 
            //Checks whether paragraph is in cell?
            if (para.IsInCell)
            {
                //Gets the template row
                row = GetTableRow(para);
                //Gets the template table
                templateTable = (row.Owner as WTable);
                WTable tempTable = templateTable.Clone();

                #region Replace Bookmark and Clone the paragraph before the table

                bookmarkNavigator.MoveToBookmark("GivingAccountNumber");
                bookmarkNavigator.ReplaceBookmarkContent("A-999999 (EUR)", true);
               
                #endregion

                #region Replace Bookmark and Clones the template table to the document

                for (int i = 0; i < 5; i++)
                {
                    //bookmarkNavigator.MoveToBookmark("AccountDate");
                    //bookmarkNavigator.ReplaceBookmarkContent("09/10/2015", true);

                    //bookmarkNavigator.MoveToBookmark("AccountReference");
                    //bookmarkNavigator.ReplaceBookmarkContent("Account Reference", true);

                    //bookmarkNavigator.MoveToBookmark("AccountDetails");
                    //bookmarkNavigator.ReplaceBookmarkContent("Account Details", true);

                    //bookmarkNavigator.MoveToBookmark("AccountAmount");
                    //bookmarkNavigator.ReplaceBookmarkContent("300", true);

                    templateTable.Rows.Add(row.Clone());
                }
                #endregion

                #region adds new table and paragraph to the document
                //Gets the index of template table
                int tableIndex = document.LastSection.Body.ChildEntities.IndexOf(templateTable);
                //Inserts the paragraph
                document.LastSection.Body.ChildEntities.Insert(tableIndex + 1, ParagraphTemplate.Clone());
                //Gets the newly inserted paragraph 
                WParagraph newParagraph = document.LastSection.Body.ChildEntities[tableIndex + 1] as WParagraph;
                //Replaces the paragraph content
                newParagraph.Replace("A-999999 (EUR)", "A-111111 (EUR)", false, false);
                //Inserts new table to the document
                document.LastSection.Body.ChildEntities.Insert(tableIndex + 2, tempTable);
                //tempTable = document.LastSection.Body.ChildEntities[tableIndex + 2] as WTable;
                #endregion

                #region Replace Bookmark and Clones the template table to the document
                for (int i = 0; i < 5; i++)
                {

                    //bookmarkNavigator.MoveToBookmark("AccountDate");
                    //bookmarkNavigator.ReplaceBookmarkContent("09/10/2015", true);

                    //bookmarkNavigator.MoveToBookmark("AccountReference");
                    //bookmarkNavigator.ReplaceBookmarkContent("Account Reference", true);

                    //bookmarkNavigator.MoveToBookmark("AccountDetails");
                    //bookmarkNavigator.ReplaceBookmarkContent("Account Details", true);

                    //bookmarkNavigator.MoveToBookmark("AccountAmount");
                    //bookmarkNavigator.ReplaceBookmarkContent("300", true);

                    tempTable.Rows.Add(row.Clone());
                }
                #endregion
            }
            

            try
            {

                //Saving the document as .docx
                document.Save( Path.Combine(GetDirectoryName, @"Documents\GenerateWord.docx"), FormatType.Word2010);

            }
            catch (Win32Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

        }

        static WTableRow GetTableRow(Entity entity)
        {
            //Checks until WTable entity
            while (!(entity is WTableRow))
            {
                if (entity.Owner != null)
                    entity = entity.Owner;
                else
                    break;
            }
            return entity as WTableRow;
        }

    }
}
